#ifndef HINPUT_H
#define HINPUT_H

#include <TROOT.h>
#include <TFile.h>
#include <TTree.h>
#include <TClonesArray.h>
#include <TH1.h>
#include <list>
#include <functional>
#include <algorithm>
#include "PParticle.h"
#include "hparticle.h"
#include "hdata.h"
#include "hfile.h"


// ****************************************************************************
class HInput
{
 public:

   HInput(const HFile& src);
   virtual ~HInput();
   void set(int n) { ptrIn->set(n); }
   void getEntry(int n) { ptrIn->getEntry(n); }
   long nentries() const { return ptrIn->nentries(); }
   int nparticles() const { return ptrIn->nparticles(); }
   HParticle read(int n) { return ptrIn->read(n); }

 private:
   
   const HFile& source;
   HData *ptrIn;
   enum EDataFormat { eUNKNOWN = 0, ePLUTO = 1, eGEANT = 2 };
   EDataFormat format;

ClassDef(HInput, 0)
};
// ****************************************************************************

#endif // HINPUT_H


