// This macro filters data
// Date: 17.11.05 by WP

#include <TROOT.h>
#include <TFile.h>
#include <TH1.h>
#include <TH2.h>
#include <TH3.h>
#include <TH3F.h>


// ****************************************************************************
class HMatrixHistogram: public TNamed
{

public:

HMatrixHistogram();
HMatrixHistogram(const char* name);
~HMatrixHistogram();

void setFile(TFile* pname);
void setXYZname(const char* x, const char* y=NULL, const char* z=NULL);
void setXYZunit(const char* x, const char* y=NULL, const char* z=NULL);

Bool_t setHisto();
Bool_t getStatus() const;
Float_t getBinContent(Float_t mom, Float_t theta, Float_t phi);
Float_t getBinContent(Float_t mom, Float_t theta); 
Float_t getBinContent(Float_t value);


private:

void setStatus(Bool_t stat);
void setVal(Float_t mom, Float_t theta, Float_t phi);
void setVal(Float_t mom, Float_t theta);
void setVal(Float_t mom);

Int_t getSize();
Int_t calcSize();

TFile *file;

Int_t size;

TH1 *hist;
Bool_t status;
TString xname, yname, zname;
TString xunit, yunit, zunit;
Int_t mapping[3];
Float_t val[3];
Float_t valscale[3];
Float_t lower_limit[3];
Float_t upper_limit[3];

ClassDef(HMatrixHistogram, 0)
};
// ****************************************************************************




