#include "hpoolfactory.h"
#include "hpidgeanttrackset.h"
#include "hgeantkine.h" 
#include "PParticle.h"
#include <TMath.h>
#include <TLorentzVector.h>

using namespace std;

// ****************************************************************************
ClassImp(HPoolFactory)

//-----------------------------------------------------------------------------
HPoolFactory::HPoolFactory(HParticlePool& ref, std::string name) : 
	name(name), number(-1), prongNumber(0), refPool(ref), ptrFH(new HPoolFactoryHandle)
{
}

//-----------------------------------------------------------------------------
HPoolFactory::~HPoolFactory() 
{
}

//-----------------------------------------------------------------------------
int HPoolFactory::count() {

   for( particleNumIter = particleComb.begin(); particleNumIter != particleComb.end(); ++particleNumIter )
   {
      // reset number of combinations for a given particle species
      particleNumIter->second = 0;
   }

   number = 1;
   for( particleNumIter = particleNum.begin(); particleNumIter != particleNum.end(); ++particleNumIter )
   {
      if (refPool.particleNum.count( particleNumIter->first ) > 0)
      {
         particleComb[ particleNumIter->first ] =
              static_cast<int>( TMath::Binomial( refPool.particleNum[ particleNumIter->first ], particleNumIter->second ) );
         number *= particleComb[ particleNumIter->first ];
      }
      else
      {
         number = 0;
      }
   }
return number;
}


