#include <fstream>
#include <iostream>
#include <string>
#include <TError.h>
#include "hsourcefile.h"


// ****************************************************************************
ClassImp(HSourceFile)


//-----------------------------------------------------------------------------
HSourceFile::HSourceFile(const char* name) : HFile() 
{
   if (0 != name)
   {
      open(name);
   }
}


//-----------------------------------------------------------------------------
HSourceFile::~HSourceFile()
{
}


//-----------------------------------------------------------------------------
Bool_t HSourceFile::open(const char* name, const char*)
{
   std::string tmp_name(name);

   // ------------------------------------------------
   // opening list of files
   // ------------------------------------------------
    if( tmp_name.find(".txt") != std::string::npos )
    {
	std::ifstream inFileList( name );
        if( 0 == inFileList )
        {
            std::cerr << "Cannot open text file: " << name << std::endl;
            return kFALSE;
        }
        char cBuffer[3000];
        while( inFileList >> cBuffer )
        {
            add( cBuffer, "read" );
	    std::cout << "Opening root source file: " << cBuffer << std::endl;
        }
    }
    else if ( tmp_name.find(".root") != std::string::npos )
    {
        add( name, "read" );
	std::cout << "Opening root source file: " << name << std::endl;
    }
    else 
    {
	std::cerr << "Unknown source file type (extension .root or .txt not found)." << std::endl;
        return kFALSE;
    }
   // ------------------------------------------------
 return kTRUE;
}


//-----------------------------------------------------------------------------
Int_t HSourceFile::write()
{
   return 0;
}



//-----------------------------------------------------------------------------
Bool_t HSourceFile::isOutput() const
{
   return kFALSE;
}

//-----------------------------------------------------------------------------
TFile* HSourceFile::getOutput() const
{
   return 0;
}

//-----------------------------------------------------------------------------
const TObject* HSourceFile::get(const char* name) const {
   std::list<TFile*>::const_iterator cIter = find_if( fileArr.begin(), fileArr.end(), std::bind2nd( IsName(), name ) );
   if (cIter == fileArr.end()) {
      return 0;
   }
 return ( dynamic_cast<const TObject*>((*cIter)->Get(name)) );
}




