#include <TROOT.h>
#include <getopt.h>
#include <stdlib.h>
#include "hrootsource.h"
#include "htaskset.h"
#include <iostream>
#include <fstream>
#include "hmatrixfile.h"
#include "hsourcefile.h"
#include "houtputfile.h"
#include "hmatrix.h"
#include "hfilter.h"
#include "hparticlepool.h"

#include "hcategory.h"
#include "PParticle.h"


//-----------------------------------------------------------------------------
int main(int argc, char **argv)
{

   HMatrixFile matrixFile;
   matrixFile.open("/u/przygoda/ACC/May06/acceptances.root");
   matrixFile.open("/u/przygoda/EFF/May06/efficiencies.root");

   HSourceFile sourceFile;
   sourceFile.open("Deltap.root");

   HOutputFile outputFile("test.root", "recreate");

   HFilter matrixFilter( matrixFile, "Test filter 2007" );
   matrixFilter.smear( "ideal" );
   matrixFilter.add( 2, "EPlusAcc" );
   matrixFilter.add( 3, "EMinusAcc" );
   matrixFilter.add( 14, "ProtonAcc" );
   matrixFilter.add( 2, "EPlusEff" );
   matrixFilter.add( 3, "EMinusEff" );
   matrixFilter.add( 14, "ProtonEff" );

   cout << matrixFilter.getName() << endl;
   matrixFilter.print();

   HParticlePool particlePool( sourceFile, outputFile, matrixFilter );
   particlePool.target("p", 0., 0., 0.);
   particlePool.beam("p", 0., 0., 2.0);

   particlePool.invariant("P");
   particlePool.add("P", "p");

   particlePool.invariant("Ep");
   particlePool.add("Ep", "ep");

   particlePool.invariant("Em");
   particlePool.add("Em", "em");

   particlePool.invariant("invEpEm");
   particlePool.add("invEpEm", "ep", "em");

   particlePool.invariant("invPEpEm");
   particlePool.add("invPEpEm", "ep", "em", "p");

   particlePool.loop();
   particlePool.write();



}

